<div ng-attr-id="test_{{::$ctrl.test.id}}"
    class="test-card"
    ng-class="$ctrl.cssClasses"
    data-source-id="{{$ctrl.test.id}}">
    <div class="test-card__col-selection">
        <md-checkbox name="testCheckbox"
            ng-if="$ctrl.canManageTestRuns"
            class="test-card__checkbox"
            aria-label="Select test"
            ng-model="$ctrl.test.selected"
            ng-change="$ctrl.onTestSelect($ctrl.test)"
            ng-true-value="true"
            ng-false-value="false">
        </md-checkbox>
    </div>
    <div class="test-card__col-main">
        <div class="test-card__header">
            <div class="test-card__info">
                <div name="testName"
                    class="test-card__title">
                    <div class="test-card__title-text">
                        {{::$ctrl.test.name}}
                        <button title="Copy to clipboard"
                            class="test-card__copy"
                            type="button"
                            ng-click="$ctrl.copyTestRunTitle()"
                            ng-class="$ctrl.cssClasses">
                            <md-icon class="test-card__copy-icon material-icons">content_copy</md-icon>
                        </button>
                    </div>
                </div>
            </div>
            <div class="test-card__labels"
                ng-if="$ctrl.test.issueReferences.length">
                <div class="issue-references__arr"
                    ng-if="$ctrl.test.issueReferences.length">
                    <test-ticket class="issue-references"
                        ng-repeat="issueReference in $ctrl.test.issueReferences track by issueReference.id"
                        jira-integration="$ctrl.jiraIntegration"
                        issue-reference="issueReference"></test-ticket>
                </div>
            </div>
            <div class="test-card__meta">
                <duration class="test-card__meta-item _duration"
                    ng-if="$ctrl.testDuration"
                    duration-in-seconds="$ctrl.testDuration">
                    <i class="test-card__meta-item-icon material-icons">timer</i>
                    <span class="test-card__meta-item-text">
                        <span ng-show="minutes">{{minutes}}m</span> <span ng-show="seconds">{{seconds}}s</span><span ng-show="!minutes && !seconds">&lt;1s</span>
                    </span>
                </duration>
                <span name="testOwner"
                    ng-if="$ctrl.test.owner"
                    class="test-card__meta-item _owner">
                    <i class="test-card__meta-item-icon material-icons">perm_identity</i>
                    <span class="test-card__meta-item-text">{{::$ctrl.test.owner}}</span>
                </span>
                <span name="testSessions"
                    ng-if="$ctrl.test.testSessionsCount"
                    ng-click="$ctrl.openSessionsSidenav()"
                    class="test-card__meta-item _sessions">
                    <i class="test-card__meta-item-icon material-icons">linear_scale</i>
                    <span class="test-card__meta-item-text">{{$ctrl.test.testSessionsCount}} Session(s)</span>
                </span>
                <span name="device"
                    ng-if="$ctrl.test.testConfig.device"
                    class="test-card__meta-item _device">
                    <i class="test-card__meta-item-icon material-icons" aria-hidden="true">phone_iphone</i>
                    <span class="test-card__meta-item-text">{{::$ctrl.test.testConfig.device}}</span>
                </span>
                <test-artifact class="test-card__meta-item _artifact"
                    ng-repeat="artifact in $ctrl.artifacts | limitTo:$ctrl.artifactsLimitCount"
                    artifact="artifact"
                    on-image-open="$ctrl.openImagesViewerModal($event, $artifact)"></test-artifact>
                <button class="test-card__meta-item _artifact-more no-animate"
                    ng-click="$ctrl.showMore('artifacts')"
                    ng-if="$ctrl.artifacts.length > $ctrl.defaultLimitCount && $ctrl.artifacts.length > $ctrl.artifactsLimitCount">
                    <md-icon>chevron_right</md-icon>
                    <span>{{$ctrl.artifacts.length - $ctrl.defaultLimitCount}}+</span>
                </button>
                <button class="test-card__meta-item _artifact-less no-animate"
                    ng-click="$ctrl.showLess('artifacts')"
                    ng-if="$ctrl.artifacts.length > $ctrl.defaultLimitCount && $ctrl.artifacts.length <= $ctrl.artifactsLimitCount">
                    <md-icon>chevron_left</md-icon>
                    <span>{{$ctrl.artifacts.length - $ctrl.defaultLimitCount}}-</span>
                </button>
                <test-label class="test-card__meta-item _label"
                    test-label="testLabel"
                    ng-if="$ctrl.isIntegrationInitialized"
                    qtest-integration="$ctrl.qtestIntegration"
                    testrail-integration="$ctrl.testrailIntegration"
                    jira-integration="$ctrl.jiraIntegration"
                    ng-repeat="testLabel in $ctrl.labels | limitTo:$ctrl.labelsLimitCount track by testLabel.id"></test-label>
                <button class="test-card__meta-item _label-more no-animate"
                    ng-click="$ctrl.showMore('labels')"
                    ng-if="$ctrl.labels.length > $ctrl.defaultLimitCount && $ctrl.labels.length > $ctrl.labelsLimitCount">
                    <md-icon>chevron_right</md-icon>
                </button>
                <button class="test-card__meta-item _label-less no-animate"
                    ng-click="$ctrl.showLess('labels')"
                    ng-if="$ctrl.labels.length > $ctrl.defaultLimitCount && $ctrl.labels.length <= $ctrl.labelsLimitCount">
                    <md-icon>chevron_left</md-icon>
                </button>
            </div>
        </div>
        <div class="test-card__stacktrace _{{$ctrl.test.status | lowercase}}"
            ng-class="{'_isBorder': $ctrl.test.message.length > $ctrl.messageTitleLengthLimit}"
            ng-if="$ctrl.test.message && ($ctrl.test.status === 'FAILED' || $ctrl.test.status === 'SKIPPED' || $ctrl.test.status === 'ABORTED')">
            <div class="test-card__stacktrace-title _{{$ctrl.test.status | lowercase}}"
                ng-if="$ctrl.test.message.length > $ctrl.messageTitleLengthLimit"
                ng-class="{_expanded: $ctrl.test.isExpanded}"
                ng-click="$ctrl.toggleStacktraceExpand($event)">
                <div class="test-card__stacktrace-title-text">{{$ctrl.test.messageTitle}}</div>
                <i class="test-card__stacktrace-arrow material-icons" ng-if="!$ctrl.test.isExpanded">expand_more</i>
                <i class="test-card__stacktrace-arrow material-icons" ng-if="$ctrl.test.isExpanded">expand_less</i>
            </div>
            <div class="test-card__stacktrace-message"
                ng-if="$ctrl.test.message.length <= $ctrl.messageTitleLengthLimit">
                {{$ctrl.test.message}}
            </div>
            <div class="test-card__stacktrace-message"
                ng-if="$ctrl.test.isExpanded"
                ng-bind-html="$ctrl.test.messageHtml"></div>
        </div>
    </div>
    <div class="test-card__col-settings">
        <md-menu class="test-card__menu" ng-if="$ctrl.canManageTestRuns">
            <md-button name="testRunSetting"
                aria-label="test run settings"
                class="test-card__menu-btn md-icon-button"
                ng-click="$mdMenu.open($event);">
                <md-icon class="material-icons">more_vert</md-icon>
                <md-tooltip md-direction="bottom">More options</md-tooltip>
            </md-button>
            <md-menu-content width="2" class="fixed-md-menu-content test-card__menu-content">
                <md-menu-item ng-click="$ctrl.changeTestStatus('PASSED');"
                    class="test-card__menu-item"
                    ng-if="$ctrl.test.status !== 'PASSED'">
                    <md-button class="test-card__menu-item-btn _green">
                        Mark as passed
                    </md-button>
                </md-menu-item>
                <md-menu-item ng-click="$ctrl.changeTestStatus('FAILED');"
                    class="test-card__menu-item"
                    ng-if="['PASSED', 'SKIPPED', 'ABORTED'].indexOf($ctrl.test.status) !== -1">
                    <md-button class="test-card__menu-item-btn _red">
                        Mark as failed
                    </md-button>
                </md-menu-item>
                <md-divider class="test-card__menu-divider"
                    ng-if="$ctrl.test.status !== 'PASSED' && $ctrl.test.message"></md-divider>
                <md-menu-item ng-click="$ctrl.showDetailsDialog($event);"
                    class="test-card__menu-item"
                    ng-if="$ctrl.test.status !== 'PASSED' && $ctrl.test.message">
                    <md-button name="testDetails" aria-label="Test details" class="test-card__menu-item-btn">
                        Link issue
                    </md-button>
                </md-menu-item>
            </md-menu-content>
        </md-menu>
    </div>
    <a class="test-card__clickable" ng-click="$ctrl.goToTestInfo($event)"></a>
</div>
